/* Memory mapper header */

#ifndef HEADER_MEMMAP_H
#define HEADER_MEMMAP_H

#include "mz80.h"

#define BLOCK_SIZE 0x8000
#define	BLOCK_HIGH block00

#define ROM1_SIZE 0x4000
#define ROM2_SIZE 0x4000
#define ROM3_SIZE 0x2000

#define	BANK_ROMS B8(00000100)
#define	BANK_ROM3 B8(00100000)
#define	BANK_VRAM B8(00001000)
#define	BANK_VADD B8(00010000)

#define BASIC1_ADDR 0x8000
#define BASIC2_ADDR 0xA000

#define MAXMEMHANDLERS 10

int memmap_init (void);
int memmap_deinit (void);
int memmap_reset (void);

int memmap_loadrom (char *name, char *dest, int size);
void memmap_init6264 (char *mem, int banks);
void memmap_init6116 (char *mem, int banks);

void memmap_mode (UINT16 port, UINT8 data, struct z80PortWrite *port_struct);
void memmap_basicrom (int upper);

struct boot_s
   {
    char romimage[6][20];
    char *dest;
    int offset;
    int size; 
    char romimage2[20];
    char romimage3[20];
   };
    
typedef struct boot_s boot_t;

#endif  /* HEADER_MEMMAP_H */
