/* Z80 PIO Header */

#ifndef HEADER_PIO_H
#define HEADER_PIO_H

#include <inttypes.h>

#include "mz80.h"

int pio_init (void);
int pio_deinit (void);
int pio_reset (void);
void pio_polling (void);
void pio_configure (int xtal, int fram_rate, int serial_rx_baud);
UINT16 pio_r (UINT16 port, struct z80PortRead *port_s);
void pio_w (UINT16 port, UINT8 data, struct z80PortWrite *port_s);

#define PIO_B_CASIN	B8(00000001)
#define PIO_B_CASOUT	B8(00000010)
#define PIO_B_KEY256TC	B8(00000010)
#define PIO_B_RS232_DTR	B8(00000100)
#define PIO_B_RS232_CTS B8(00001000)
#define PIO_B_RS232_RX	B8(00010000)
#define PIO_B_RS232_TX	B8(00100000)
#define PIO_B_SPEAKER	B8(01000000)
#define PIO_B_NETDIR	B8(10000000)
#define PIO_B_CLOCK	B8(10000000)

struct pio_s
{
 UINT8 data;
 UINT8 cont;
 uint8_t mode;
 uint8_t vector;  
 uint8_t maskword; 
 uint8_t direction; 
 int action;
 int ienable;
 int andor;
 int hilo;
 int ienableff;
 int pending; 
};

typedef struct pio_s pio_t;

#endif     /* HEADER_PIO_H */
