//******************************************************************************
//*                                  uBee512                                   *
//*         An emulator for the Microbee Z80 FDD and ROM based models          *
//*                                                                            *
//*               Serial Communications Controller (SCC) module                *
//*                                                                            *
//*                   Copyright (C) 2007-2008 Stewart Kay                      *
//******************************************************************************
//
// Emulates the Serial Communications Controller (SCC) module
//
//==============================================================================
// ChangeLog (most recent entries are at top)
//==============================================================================
// v2.3.0 - 18 December 2007, S.J.Kay
// - Created a new file to implement the Z80 SCC emulation.

//==============================================================================
/*
 *  uBee512 - An emulator for the Microbee Z80 FDD and ROM based models. 
 *  Copyright (C) 2007-2008 Stewart Kay
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/ 
//==============================================================================

#include <stdio.h>
#include <stdlib.h>

#include "mz80.h"
#include "scc.h"
#include "ubee512.h"

#include "macros.h"

//==============================================================================
// SCC initialise
//
//   pass: void
// return: int 				0
//==============================================================================
int scc_init (void)
{
 return 0;
}

//==============================================================================
// SCC de-initialise
//
//   pass: void
// return: int 				0
//==============================================================================
int scc_deinit (void)
{
 return 0;
}

//==============================================================================
// SCC reset
//
//   pass: void
// return: int 				0
//==============================================================================
int scc_reset (void)
{
 return 0;
}

//==============================================================================
//   pass: UINT16 port
//         struct z80PortRead *port_s
// return: UINT16			0
//==============================================================================
UINT16 scc_r (UINT16 port, struct z80PortRead *port_s)
{
 return 0;
}

//==============================================================================
//   pass: UINT16 port
//         UINT8 data
//         struct z80PortWrite *port_s
// return: void
//==============================================================================
void scc_w (UINT16 port, UINT8 data, struct z80PortWrite *port_s)
{
}
