/* VDU Header */

#ifndef HEADER_VDU_H
#define HEADER_VDU_H

#include "ubee512.h"
#include "mz80.h"

#define VIDEORAMSIZE  2048
#define CHARROMSIZE   4096
#define PCGRAMSIZE    2048

int vdu_init (void);
int vdu_deinit (void);
int vdu_reset (void);

void vdu_switchvideo_in (void);
void vdu_switchvideo_out (void);

UINT8 vdu_vidmem_r (UINT32 addr, struct MemoryReadByte *mem_s);
void vdu_vidmem_w (UINT32 addr, UINT8 data, struct MemoryWriteByte *mem_s);

UINT16 vdu_colcont_r (UINT16 port, struct z80PortRead *port_s);
void vdu_colcont_w (UINT16 port, UINT8 data, struct z80PortWrite *port_s);

UINT16 vdu_colwait_r (UINT16 port, struct z80PortRead *port_s);
void vdu_colwait_w (UINT16 port, UINT8 data, struct z80PortWrite *port_s);

UINT16 vdu_lvdat_r (UINT16 port, struct z80PortRead *port_s);
void vdu_lvdat_w (UINT16 port, UINT8 data, struct z80PortWrite *port_s);

void vdu_latchrom (UINT16 port, UINT8 data, struct z80PortWrite *port_s);

#endif /* HEADER_VDU_H */
