type
   ub_version_t = record
       cmd : integer;
      ver1 : integer;
      ver2 : integer;
      ver3 : integer;
   end;

function KeyCheck : char;
var
   key : char;
begin
   while keypressed do
      read(kbd, key);
   repeat until keypressed;
   read(kbd, key);
   KeyCheck := key;
end;

function locase (ch : char) : char;
begin
   if ch in ['A'..'Z'] then
      locase := chr(ord(ch) + $20)
   else
      locase := ch
end;

function GetHostType : integer;
var
   status : ub_cmdres_t;
begin
   status.cmd := $01;         { sub-function: Get host system information }
   port[255] := $00;                                   { status functions }
   port[255] := lo(addr(status));
   port[255] := hi(addr(status));
   GetHostType := status.res;                         { 0=win32, 1=unices }
end;

function exec_file_function (cmd : integer) : integer;
begin
   filex.cmd := cmd;                                       { sub-function }
   filex.id := $AA55;                                          { check ID }
   port[255] := $50;                                     { file functions }
   port[255] := lo(addr(filex));
   port[255] := hi(addr(filex));
   exec_file_function := filex.res;                              { result }
end;

function exec_dir_function (cmd : integer) : integer;
begin
   dirx.cmd := cmd;                                        { sub-function }
   dirx.id := $AA55;                                           { check ID }
   port[255] := $60;                                { directory functions }
   port[255] := lo(addr(dirx));
   port[255] := hi(addr(dirx));
   exec_dir_function := dirx.res;                               { result }
end;

procedure ParameterUpcasing (var s : String255);
var
   count : integer;
   i     : integer;
begin
   i := 1;
   while (i <= length(s)) do
      begin
         if (s[i] = '''') then
            begin
               delete(s, i, 1);                          { delete the ''' }
               if (i <= length(s)) then
                  case s[i] of
                         '''' : i := i + 1;             { use the 2nd ''' }
                     '0'..'9' : begin
                                   count := ord(s[i]) - ord('0');
                                   if (count = 0) then
                                      count := 10;
                                   delete(s, i, 1);    { delete the digit }
                                   while ((count <> 0) and (i <= length(s))) do
                                      begin
                                         s[i] := upcase(s[i]);
                                         count := count - 1;
                                         i := i + 1;
                                      end;
                                end
                             else
                                begin
                                   s[i] := upcase(s[i]);
                                   i := i + 1;
                                end;
                  end;
            end
         else
            i := i + 1;
      end;
end;

function ParmCount : integer;
var
   i, PrmCnt, PrmLen : integer;
begin
   i := 1;
   PrmCnt := 0;
   PrmLen := length(ComLne);
   while i <= PrmLen do
      begin
         while (i <= PrmLen) and (ComLne[i] = ' ') do
            i := i + 1;
         if i <= PrmLen then
            PrmCnt := PrmCnt + 1;
         if ComLne[i] = '-' then
            i := i + 1;
         while (i <= PrmLen) and (not(ComLne[i] in [' ', '-', '"'])) do
            i := i + 1;
         if (ComLne[i] = '"') then
            begin
               i := i + 1;
               while (i <= PrmLen) and (ComLne[i] <> '"') do
                  i := i + 1;
               i := i + 1;
           end;
      end;
   ParmCount := PrmCnt
end;

function ParamStr (PrmNmb : integer) : String255;
var
   i, PrmCnt, PrmLen : integer;
   PrmStr            : String255;
begin
   i := 1;
   PrmCnt := 0;
   PrmStr := '';
   PrmLen := length(ComLne);
   while (i <= PrmLen) and (PrmCnt < PrmNmb) do
      begin
         while (i <= PrmLen) and (ComLne[i] = ' ') do
            i := i + 1;
         if i <= PrmLen then
            PrmCnt := PrmCnt + 1;
         if ComLne[i] = '-' then
            begin
               PrmStr := '-';
               i := i + 1
            end
         else
            PrmStr := '';

         while (i <= PrmLen) and (not(ComLne[i] in [' ', '-', '"'])) do
            begin
               PrmStr := PrmStr + ComLne[i];
               i := i + 1
            end;
         if (ComLne[i] = '"') then
            begin
               i := i + 1;
               while (i <= PrmLen) and (ComLne[i] <> '"') do
                  begin
                     PrmStr := PrmStr + ComLne[i];
                     i := i + 1
                  end;
               i := i + 1;
            end;
      end;
   ParamStr := PrmStr
end;

function CheckEmulatorVersion (v1, v2, v3 : integer) : integer;
const
   EMUPORT=$FF;
var
   version : ub_version_t;
   name    : string[100];
   i       : integer;
   c       : char;
   res     : integer;
begin
   res := 0;
   name := '';
   i := 0;
   repeat
      i := i + 1;
   until (port[EMUPORT] = 0) or (i = 100);

   if (i <> 100) then
      begin
         i := 0;
         repeat
            i := i + 1;
            c := upcase(chr(port[EMUPORT]));
            if (c <> #0) then
               name := name + c;
         until ((c = #0) or (i = 100));

         if (name = 'UBEE512') then
            begin
               res := 1;                              { incorrect version }
               version.cmd := $00;            { sub-function: get version }
               port[255] := $00;                       { status functions }
               port[255] := lo(addr(version));
               port[255] := hi(addr(version));
               if (version.ver1 >= v1) then
                  begin
                     if (version.ver1 > v1) then
                        res := 2
                     else
                        if (version.ver2 >= v2) then
                           begin
                              if (version.ver2 > v2) then
                                 res := 2
                              else
                                 if (version.ver3 >= v3) then
                                    res := 2;
                           end;
                  end;
            end;
      end;
   CheckEmulatorVersion := res;
end;

function Startup : boolean;
var
   x : integer;
begin
   Startup := false;
   x := CheckEmulatorVersion(EMU_V1, EMU_V2, EMU_V3);
   if (x = 0) then
      writeln('Must be run under the uBee512 emulator! (v2.2.0 onwards)')
   else
      if (x = 1) then
         begin
            writeln('Not the correct uBee512 emulator version!');
            writeln('Requires v', EMU_V1, '.', EMU_V2, '.', EMU_V3, ' or later');
         end
      else
         begin
            if (GetHostType = 0) then
               slashchar := '\'                                 { Windows }
            else
               slashchar := '/';                                 { Unices }
            ComLne := ComLneC;  { start with CP/M command line parameters }
            Startup := true;
         end
end;
